import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkLog, ThinkLogParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkLog(params: ThinkLogParam) {
  const res = await request.get<ApiResult<PageResult<ThinkLog>>>(
    THINK_API_URL + '/think/think-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkLog(params?: ThinkLogParam) {
  const res = await request.get<ApiResult<ThinkLog[]>>(
    THINK_API_URL + '/think/think-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkLog(data: ThinkLog) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkLog(data: ThinkLog) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkLog(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkLog(id: number) {
  const res = await request.get<ApiResult<ThinkLog>>(
    THINK_API_URL + '/think/think-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
